#include <v_lib.h>
#include "istrings.h"

GLOBAL_STRING(ipl_usage,
	"Image processing language interpreter.\n"
	"Version 0.9.alpha.2 by Vladimir A. Smirnov.\n"
	"Usage: " IPL_BASENAME "<scriptfile>\n"
	"For brief language description, type " IPL_BASENAME " --help-ipl.\n")

/* can't be very long: will pass it to printf() */
GLOBAL_STRING(ipl_exit_status,
	"IPL run completed: %s. (alloc: %u bytes; leak: %u bytes)\n")

GLOBAL_STRING(ipl_key_global,"global")
GLOBAL_STRING(ipl_key_random_seed,"random_seed")
GLOBAL_STRING(ipl_key_alias,"alias")
GLOBAL_STRING(ipl_unable_to_open,"unable to open: ")
GLOBAL_STRING(ipl_success,"success")
GLOBAL_STRING(ipl_error,"error(s)")

GLOBAL_STRING(ipl_open_brace,IPL_OPEN_BRACE)
GLOBAL_STRING(ipl_close_brace,IPL_CLOSE_BRACE)
GLOBAL_STRING(ipl_open_bracket,IPL_OPEN_BRACKET)
GLOBAL_STRING(ipl_close_bracket,IPL_CLOSE_BRACKET)
GLOBAL_STRING(ipl_comma,IPL_COMMA)

GLOBAL_STRING(ipl_key_void,"void")
GLOBAL_STRING(ipl_key_true,"true")
GLOBAL_STRING(ipl_key_false,"false")

GLOBAL_STRING(ipl_key_source_space,"source_space")
GLOBAL_STRING(ipl_key_rgb,"RGB")
GLOBAL_STRING(ipl_key_rgba,"RGBA")
GLOBAL_STRING(ipl_key_hsv,"HSV")
GLOBAL_STRING(ipl_key_cie,"CIE")
GLOBAL_STRING(ipl_key_red,"red")
GLOBAL_STRING(ipl_key_green,"green")
GLOBAL_STRING(ipl_key_blue,"blue")
GLOBAL_STRING(ipl_key_alpha,"alpha")
GLOBAL_STRING(ipl_key_hue,"hue")
GLOBAL_STRING(ipl_key_saturation,"saturation")
GLOBAL_STRING(ipl_key_value,"value")
GLOBAL_STRING(ipl_key_cieX,"cieX")
GLOBAL_STRING(ipl_key_cieY,"cieY")
GLOBAL_STRING(ipl_key_cieZ,"cieZ")
GLOBAL_STRING(ipl_key_targets,"targets")
GLOBAL_STRING(ipl_key_output,"output")
GLOBAL_STRING(ipl_key_matrix,"matrix")
GLOBAL_STRING(ipl_desc_matrix,"definition of matrix")
GLOBAL_STRING(ipl_key_vector,"vector")
GLOBAL_STRING(ipl_desc_vector,"definition of vector")
GLOBAL_STRING(ipl_key_decomposition,"decomposition")
GLOBAL_STRING(ipl_desc_decomposition,"definition of decomposition")
GLOBAL_STRING(ipl_key_state,"state")
GLOBAL_STRING(ipl_tab_string,"\t")
GLOBAL_STRING(ipl_eol_string,"\n")
GLOBAL_STRING(ipl_key_source_dimension,"source_dimension")
GLOBAL_STRING(ipl_key_depth_range,"depth_range")
GLOBAL_STRING(ipl_key_area_range,"area_range")
GLOBAL_STRING(ipl_key_value_range,"value_range")
GLOBAL_STRING(ipl_key_at_depth,"at_depth")
GLOBAL_STRING(ipl_key_leafs,"leafs")
GLOBAL_STRING(ipl_key_values,"values")
GLOBAL_STRING(ipl_key_histogram,"histogram")

/* generic operations */

GLOBAL_STRING(ipl_key_generic_constant,"constant")
GLOBAL_STRING(ipl_desc_generic_constant,
	"constant <real value>; sets all elements to given value")

GLOBAL_STRING(ipl_key_generic_uniform,"uniform")
GLOBAL_STRING(ipl_desc_generic_uniform,
	"uniform <real lower,upper>; sets all elements to samples of "
	"uniform distribution with given [lower,upper] bounds")

GLOBAL_STRING(ipl_key_generic_gaussian,"gaussian")
GLOBAL_STRING(ipl_desc_generic_gaussian,
	"gaussian <real mean,standard_deviation>; sets all elements to "
	"samples of normal distribution with given mean and standard "
	"deviation")

GLOBAL_STRING(ipl_key_generic_puts,"puts")
GLOBAL_STRING(ipl_desc_generic_puts,
	"writes next token of script to standard output")

/* matrix operations */

GLOBAL_STRING(ipl_key_matrix_copy,"copy")
GLOBAL_STRING(ipl_desc_matrix_copy,
	"copy <matrix src>; copies contents of given matrix into current")

GLOBAL_STRING(ipl_key_matrix_input,"input")
GLOBAL_STRING(ipl_desc_matrix_input,
	"input <string image_name,channel_name>; loads color channel from disk image")

GLOBAL_STRING(ipl_key_matrix_get,"get")
GLOBAL_STRING(ipl_desc_matrix_get,
	"get <int dest_left,dest_top;"
	"matrix src;int src_left,src_top,src_right,src_bottom>; "
	"copies contents of source rectangle at [dest_left,dest_top] of current matrix")

GLOBAL_STRING(ipl_key_matrix_resize,"resize")
GLOBAL_STRING(ipl_desc_matrix_resize,
	"resize <int new_width,new_height>; "
	"resizes the matrix using bilinear interpolation")

GLOBAL_STRING(ipl_key_matrix_save,"save")
GLOBAL_STRING(ipl_desc_matrix_save,
	"save <string file_name>; writes matrix to text file")

GLOBAL_STRING(ipl_key_matrix_row_linear,"row_linear")
GLOBAL_STRING(ipl_desc_matrix_row_linear,
	"row_linear <real min,max>; linearly interpolates from given 'min' "
	"to given 'max' and writes results to every row")

GLOBAL_STRING(ipl_key_matrix_col_linear,"col_linear")
GLOBAL_STRING(ipl_desc_matrix_col_linear,
	"col_linear <real min,max>; linearly interpolates from given 'min' "
	"to given 'max' and writes results to every column")

GLOBAL_STRING(ipl_key_matrix_fourier_forward,"fourier_forward")
GLOBAL_STRING(ipl_desc_matrix_fourier_forward,
	"replaces matrix by its 2D forward Fourier transform")

GLOBAL_STRING(ipl_key_matrix_fourier_inverse,"fourier_inverse")
GLOBAL_STRING(ipl_desc_matrix_fourier_inverse,
	"replaces 2D forward Fourier transform by its inversion")

GLOBAL_STRING(ipl_key_matrix_scale,"scale")
GLOBAL_STRING(ipl_desc_matrix_scale,
	"scale <real value>; multiplies all elements by given 'value'")

GLOBAL_STRING(ipl_key_matrix_offset,"offset")
GLOBAL_STRING(ipl_desc_matrix_offset,
	"offset <real value>; performs either addition of given 'value' to "
	"all elements of (spatial-domain) matrix, or phase addition for "
	"frequency-domain matrix")

GLOBAL_STRING(ipl_key_matrix_mat_offset,"mat_offset")
GLOBAL_STRING(ipl_desc_matrix_mat_offset,
	"mat_offset <matrix other>; performs either per-element addition of"
	"elements of two (spatial-domain) matrices, or per-element phase "
	"addition of two frequency-domain matrices")

GLOBAL_STRING(ipl_key_matrix_mat_scale,"mat_scale")
GLOBAL_STRING(ipl_desc_matrix_mat_scale,
	"mat_scale <matrix other>; per-element multiplication of two "
	"matrices or (complex) multiplication of two Fourier transforms "
	"(useful for computing convolutions)")

GLOBAL_STRING(ipl_key_matrix_mat_unscale,"mat_unscale")
GLOBAL_STRING(ipl_desc_matrix_mat_unscale,
	"mat_unscale <matrix other>; per-element division of two matrices"
	"or (complex) division of two Fourier transforms (useful for "
	"computing deconvolutions)")

GLOBAL_STRING(ipl_key_matrix_zero_rows,"zero_rows")
GLOBAL_STRING(ipl_desc_matrix_zero_rows,
	"zero_rows <int min,max>; clears rows in range ['min','max'] "
	"(operates correctly with Fourier transforms; useful for "
	"frequency-domain filtering)")

GLOBAL_STRING(ipl_key_matrix_zero_cols,"zero_cols")
GLOBAL_STRING(ipl_desc_matrix_zero_cols,
	"zero_cols <int min,max>; clears columns in range ['min','max'] "
	"(operates correctly with Fourier transforms; useful for "
	"frequency-domain filtering)")

GLOBAL_STRING(ipl_key_matrix_band_reject,"band_reject")
GLOBAL_STRING(ipl_desc_matrix_band_reject,
	"band_reject <int min,max>; clears both rows and columns in range "
	"['min','max'] (operates correctly with Fourier transforms; useful "
	"for frequency-domain filtering)")

GLOBAL_STRING(ipl_key_matrix_band_pass,"band_pass")
GLOBAL_STRING(ipl_desc_matrix_band_pass,
	"band_pass <int min,max>; clears both rows and columns outside the "
	"range ['min','max'] (operates correctly with Fourier transforms; "
	"useful for frequency-domain filtering)")

GLOBAL_STRING(ipl_key_matrix_adjust_contrast,"adjust_contrast")
GLOBAL_STRING(ipl_desc_matrix_adjust_contrast,
	"adjust_contrast <real min,max>; linearly interpolates range "
	"['min';'max'] in current (spatial-domain) matrix to range [0,1]; "
	"useful for selecting the only specific (a-priori known) range "
	"for visualizing at full contrast (shouldn't be confused with "
	"\"normalize\" operation)")

GLOBAL_STRING(ipl_key_matrix_normalize,"normalize")
GLOBAL_STRING(ipl_desc_matrix_normalize,
	"linearly transforms all elements in such a way that minimal value "
	"of matrix becomes 0, and maximal becomes 1")

GLOBAL_STRING(ipl_key_matrix_range_normalize,"range_normalize")
GLOBAL_STRING(ipl_desc_matrix_range_normalize,
	"range_normalize <real new_min,new_max>; linearly transforms all "
	"elements in such a way that minimal value of matrix becomes "
	"new_min, and maximal becomes new_max")

GLOBAL_STRING(ipl_key_matrix_gamma_correction,"gamma_correction")
GLOBAL_STRING(ipl_desc_matrix_gamma_correction,
	"gamma_correction <vector curve>; performs arbitrary transform of "
	"all elements in such a way that minimal value of matrix becomes "
	"equal to first element of 'curve', and maximal one becomes equal to "
	"last element of 'curve'; uses 'curve' as input-to-output function "
	"(useful for color reduction and histogram equalization)")

GLOBAL_STRING(ipl_key_matrix_draw_decomposition,"draw_decomposition")
GLOBAL_STRING(ipl_desc_matrix_draw_decomposition,
	"draw_decomposition <decomposition decomp>; draws sparse "
	"representation of binary decomposition 'decomp'")

GLOBAL_STRING(ipl_key_matrix_draw_decomposition_scale,
	"draw_decomposition_scale")
GLOBAL_STRING(ipl_desc_matrix_draw_decomposition_scale,
    	"draw_decomposition_scale <decomposition decomp;vector colors>; "
    	"draws sparse representation of binary decomposition 'decomp' "
    	"using at each depth colors from vector 'colors'")

GLOBAL_STRING(ipl_key_matrix_draw_decomposition_linear,
	"draw_decomposition_linear")
GLOBAL_STRING(ipl_desc_matrix_draw_decomposition_linear,
	"draw_decomposition_linear <decomposition decomp;real min,max>; "
	"draws sparse representation of binary decomposition 'decomp' "
	"using at each depth colors from 'min' up to 'max'")

GLOBAL_STRING(ipl_key_matrix_matrix_transform,"matrix_transform")
GLOBAL_STRING(ipl_desc_matrix_matrix_transform,
	"matrix_transform <string name[(real arg1,...,argN)]>; "
	"executes transform 'name' for current spatial-domain matrix")

GLOBAL_STRING(ipl_key_matrix_cartesian_transform,"cartesian_transform")
GLOBAL_STRING(ipl_desc_matrix_cartesian_transform,
	"cartesian_transform <string name[(real arg1,...,argN)]>; "
	"executes transform 'name' for current frequency-domain matrix, "
	"passing (Re,Im) pairs on each iteration of each 'pass' section")

GLOBAL_STRING(ipl_key_matrix_polar_transform,"polar_transform")
GLOBAL_STRING(ipl_desc_matrix_polar_transform,
	"polar_transform <string name[(real arg1,...,argN)]>; "
	"executes transform 'name' for current frequency-domain matrix, "
	"passing (Magnitude,Phase) pairs on each iteration of each 'pass' "
	"section")

GLOBAL_STRING(ipl_key_matrix_matrix_pair_transform,
	"matrix_pair_transform")
GLOBAL_STRING(ipl_desc_matrix_matrix_pair_transform,
	"matrix_pair_transform <string name[(real arg1,...,argN)];"
	"matrix other>; executes transform 'name' for current and 'other' "
	"matrices (both matrices must be in spatial domain)")

GLOBAL_STRING(ipl_key_matrix_cartesian_pair_transform,
	"cartesian_pair_transform")
GLOBAL_STRING(ipl_desc_matrix_cartesian_pair_transform,
	"cartesian_pair_transform <string name[(real arg1,...,argN)];"
	"matrix other>; executes transform 'name' for current and 'other' "
	"matrices (both matrices must be in frequency domain), passing "
	"(Re1,Im1) and (Re1,Im2) pairs on each iteration")

GLOBAL_STRING(ipl_key_matrix_polar_pair_transform,
	"polar_pair_transform")
GLOBAL_STRING(ipl_desc_matrix_polar_pair_transform,
	"polar_pair_transform <string name[(real arg1,...,argN)];"
	"matrix other>; executes transform 'name' for current and 'other' "
	"matrices (both matrices must be in frequency domain), passing "
	"(Magnitude1,Phase1) and (Magnitude1,Phase2) pairs on each iteration")

GLOBAL_STRING(ipl_key_matrix_spectrum,"spectrum")
GLOBAL_STRING(ipl_desc_matrix_spectrum,
	"replaces current frequency-domain matrix by its (half-sized) "
	"power spectrum estimation (adds maximal and zero frequencies)")

/* vector operations */

GLOBAL_STRING(ipl_key_vector_copy,"copy")
GLOBAL_STRING(ipl_desc_vector_copy,
	"copy <vector src>; copies contents of 'src' into current vector")

GLOBAL_STRING(ipl_key_vector_save,"save")
GLOBAL_STRING(ipl_desc_vector_save,
	"save <string file_name>; writes vector to text file")

GLOBAL_STRING(ipl_key_vector_linear,"linear")
GLOBAL_STRING(ipl_desc_vector_linear,
	"linear <real min,max>; linearly interpolates from given 'min' "
	"to given 'max'")

GLOBAL_STRING(ipl_key_vector_histogram,"histogram")
GLOBAL_STRING(ipl_desc_vector_histogram,
	"histogram <matrix src>; computes histogram of given 'src', "
	"lower bound of first bin equal to minimal element of 'src', "
	"upper bound of last bin equal to maximal element of 'src'")

GLOBAL_STRING(ipl_key_vector_range_histogram,"range_histogram")
GLOBAL_STRING(ipl_desc_vector_range_histogram,
	"range_histogram <matrix src;real min,max>; computes histogram "
	"of given 'src', lower bound of first bin equal to 'min', upper "
	"bound of last bin equal to 'max'")

GLOBAL_STRING(ipl_key_vector_histogram_with_coords,"histogram_with_coords")
GLOBAL_STRING(ipl_desc_vector_histogram_with_coords,
	"histogram_with_coords <matrix src;vector coords>; same as "
	"\"histogram\", but also stores centers of each bins to 'coords'")

GLOBAL_STRING(ipl_key_vector_range_histogram_with_coords,
	"range_histogram_with_coords")
GLOBAL_STRING(ipl_desc_vector_range_histogram_with_coords,
	"range_histogram_with_coords <matrix src;real min,max;vector coords>; "
	"same as \"range_histogram\", but also stores centers of each bins "
	"to 'coords'")

GLOBAL_STRING(ipl_key_vector_integrate,"integrate")
GLOBAL_STRING(ipl_desc_vector_integrate,
	"computes running sum (discrete integral) of current vector")

GLOBAL_STRING(ipl_key_vector_normalize,"normalize")
GLOBAL_STRING(ipl_desc_vector_normalize,
	"linearly transforms all elements in such a way that minimal value "
	"of vector becomes 0, and maximal becomes 1")

GLOBAL_STRING(ipl_key_vector_range_normalize,"range_normalize")
GLOBAL_STRING(ipl_desc_vector_range_normalize,
	"range_normalize <real new_min,new_max>; linearly transforms all "
	"elements in such a way that minimal value of vector becomes "
	"new_min, and maximal becomes new_max")

GLOBAL_STRING(ipl_key_vector_vector_transform,"vector_transform")
GLOBAL_STRING(ipl_desc_vector_vector_transform,
	"vector_transform <string name[(real arg1,...,argN)]>; "
	"executes transform 'name' for current spatial-domain vector")

GLOBAL_STRING(ipl_key_vector_vector_pair_transform,"vector_pair_transform")
GLOBAL_STRING(ipl_desc_vector_vector_pair_transform,
	"vector_pair_transform <string name[(real arg1,...,argN)];vector other>; "
	"executes transform 'name' for current and 'other' spatial-domain vectors")

/* decomposition operations */

GLOBAL_STRING(ipl_key_decomposition_decompose,"decompose")
GLOBAL_STRING(ipl_desc_decomposition_decompose,
	"decompose <matrix src;real thresold;int histogram_divisions>; "
	"decomposes matrix 'src' with given 'thresold' and "
	"'histogram_divisions'")

GLOBAL_STRING(ipl_key_decomposition_save,"save")
GLOBAL_STRING(ipl_desc_decomposition_save,
	"save <string file_name;boolean save_values,relative_frequencies>; "
	"saves decomposition to text file 'file_name'")

/* help strings */

GLOBAL_STRING(ipl_known_block_types,"Known top-level block types:\n")
GLOBAL_STRING(ipl_valid_operations,"Valid operations")

/* built-in functions */

GLOBAL_STRING(ipl_key_width_of,"width_of")
GLOBAL_STRING(ipl_desc_width_of,"returns number of cols in given matrix")
GLOBAL_STRING(ipl_key_height_of,"height_of")
GLOBAL_STRING(ipl_desc_height_of,"returns number of cols in given matrix")
GLOBAL_STRING(ipl_key_size_of,"size_of")
GLOBAL_STRING(ipl_desc_size_of,"returns number of elements in given vector")
GLOBAL_STRING(ipl_key_depth_of,"depth_of")
GLOBAL_STRING(ipl_desc_depth_of,"returns depth of given binary decomposition")
GLOBAL_STRING(ipl_key_user_input,"input")
GLOBAL_STRING(ipl_desc_user_input,"reads number from standard input")

GLOBAL_STRING(ipl_known_transforms_str,"Known transforms:\n")
GLOBAL_STRING(ipl_valid_builtin_vars_str,"built-in variables valid for ")
GLOBAL_STRING(ipl_builtin_consts_str,"Built-in constants (all transforms):\n")
GLOBAL_STRING(ipl_key_step,"step")
GLOBAL_STRING(ipl_key_pass,"pass")

/* efunc.c */

GLOBAL_STRING(ipl_key_function,"function")

/* state.c */

GLOBAL_STRING(ipl_key_custom_width,"custom_width")
GLOBAL_STRING(ipl_key_custom_size,"custom_size")
GLOBAL_STRING(ipl_key_custom_height,"custom_height")
GLOBAL_STRING(ipl_key_input_powers2,"input_powers2")
GLOBAL_STRING(ipl_key_input_square,"input_square")
GLOBAL_STRING(ipl_key_frequency_domain,"frequency_domain")
GLOBAL_STRING(ipl_known_state_fields,"Known state fields:\n")
GLOBAL_STRING(ipl_key_integer,"integer")
GLOBAL_STRING(ipl_key_unsigned_integer,"unsigned integer")
GLOBAL_STRING(ipl_key_boolean,"boolean")
GLOBAL_STRING(ipl_key_real,"real")
GLOBAL_STRING(ipl_key_unknown_type,"[unknown type]")
GLOBAL_STRING(ipl_key_dump,"dump")
